/*
 * sisnap.c
 *
 */

#include <stdlib.h>
#include <stdio.h>

#include "savepgm.h"
#include "cam.h"

#define BUFSZ   (1280*1024)

static unsigned char buf[BUFSZ];

int main(int argc, char *argv[])
{
    struct cam *c;
    unsigned w, h;

    if (argc < 4) {
        fprintf(stderr, "usage: %s DEV WIDTH HEIGHT [FILENAME]\n", argv[0]);
        return 1;
    }

    c = cam_open(argv[1]);
    if (!c)
        exit(1);

    w = atoi(argv[2]);
    h = atoi(argv[3]);
    if (cam_set_window(c, (c->max_w - w) / 2, (c->max_h - h) / 2, w, h) < 0)
        exit(1);

    if (cam_read_frame(c, buf))
        exit(1);

    cam_close(c);

    if (argc > 4)
        save_pgm(argv[4], buf, c->w, c->h);
    return 0;
}
